"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var p_lazy_1 = __importDefault(require("p-lazy"));
var loadjs_1 = __importDefault(require("loadjs"));
var get_script_location_1 = require("./helpers/get-script-location");
var css_loader_1 = require("./helpers/css-loader");
require("unfetch/polyfill");
var url_join_1 = __importDefault(require("url-join"));
var AsyncAssetsLoader = /** @class */ (function () {
    function AsyncAssetsLoader(props) {
        var _this = this;
        if (props === void 0) { props = {}; }
        this.props = {
            assetsPath: '/',
            assetsFile: 'assets.json',
            scriptSelector: 'assets-loader',
            chunkAttribute: 'data-chunks',
            baseChunks: [],
        };
        this.init = function () { return __awaiter(_this, void 0, void 0, function () {
            var assetContent, chunkList;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.fetchAssetContent()];
                    case 1:
                        assetContent = _a.sent();
                        chunkList = this.chunkList;
                        if (assetContent) {
                            chunkList.forEach(function (chunkName) {
                                if (assetContent[chunkName]) {
                                    var _a = assetContent[chunkName], _b = _a.css, css = _b === void 0 ? [] : _b, _c = _a.js, js = _c === void 0 ? [] : _c;
                                    if (js) {
                                        _this.loadJsChunkList(js);
                                    }
                                    if (css) {
                                        _this.loadCssChunkList(css);
                                    }
                                }
                            });
                        }
                        return [2 /*return*/];
                }
            });
        }); };
        /**
         * @ignore
         */
        this.fetchAssetContent = function () { return __awaiter(_this, void 0, void 0, function () {
            var _a, assetsDirUrl, currentScript, assetsFile, url, response, status_1, ok, e_1;
            var _b, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _a = this, assetsDirUrl = _a.assetsDirUrl, currentScript = _a.currentScript;
                        _d.label = 1;
                    case 1:
                        _d.trys.push([1, 5, , 6]);
                        assetsFile = (_c = (_b = currentScript.getAttribute('data-assets-file')) !== null && _b !== void 0 ? _b : this.props.assetsFile) !== null && _c !== void 0 ? _c : 'assets.json';
                        url = url_join_1.default([assetsDirUrl, assetsFile]);
                        return [4 /*yield*/, window.fetch(url_join_1.default([assetsDirUrl, assetsFile]))];
                    case 2:
                        response = _d.sent();
                        status_1 = response.status, ok = response.ok;
                        if (!ok) return [3 /*break*/, 4];
                        return [4 /*yield*/, response.json()];
                    case 3: return [2 /*return*/, _d.sent()];
                    case 4: throw new Error("There was an error while sending the request " + url + "[" + status_1.toString() + "]");
                    case 5:
                        e_1 = _d.sent();
                        console.error(e_1);
                        return [3 /*break*/, 6];
                    case 6: return [2 /*return*/];
                }
            });
        }); };
        /**
         * @ignore
         */
        this.loadCssChunkList = function (chunks) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                if (typeof chunks === 'string') {
                    return [2 /*return*/, this.loadCssChunk(chunks)];
                }
                chunks.forEach(function (chunk) { return _this.loadCssChunk(chunk); });
                return [2 /*return*/];
            });
        }); };
        /**
         * @ignore
         */
        this.loadCssChunk = function (chunkFile) { return __awaiter(_this, void 0, void 0, function () {
            var url;
            return __generator(this, function (_a) {
                url = url_join_1.default([this.assetsDirUrl, chunkFile]);
                try {
                    return [2 /*return*/, new p_lazy_1.default(function (resolve) { return resolve(css_loader_1.loadCSS(url)); })];
                }
                catch (e) {
                    console.warn(e);
                }
                return [2 /*return*/];
            });
        }); };
        /**
         * @ignore
         */
        this.loadJsChunkList = function (chunks) { return __awaiter(_this, void 0, void 0, function () {
            var _this = this;
            return __generator(this, function (_a) {
                if (typeof chunks === 'string') {
                    return [2 /*return*/, this.loadJsChunk(chunks)];
                }
                chunks.forEach(function (chunk) { return _this.loadJsChunk(chunk); });
                return [2 /*return*/];
            });
        }); };
        /**
         * @ignore
         */
        this.loadJsChunk = function (chunkFile) { return __awaiter(_this, void 0, void 0, function () {
            var url;
            return __generator(this, function (_a) {
                url = url_join_1.default([this.assetsDirUrl, chunkFile]);
                try {
                    return [2 /*return*/, new p_lazy_1.default(function (resolve) { return resolve(loadjs_1.default(url, { returnPromise: true })); })];
                }
                catch (e) {
                    console.warn(e);
                }
                return [2 /*return*/];
            });
        }); };
        this.props = __assign(__assign({}, this.props), props);
    }
    Object.defineProperty(AsyncAssetsLoader.prototype, "currentScript", {
        /**
         * @ignore
         */
        get: function () {
            var _a = this.props.scriptSelector, scriptSelector = _a === void 0 ? 'assetsLoader' : _a;
            var scriptElement = get_script_location_1.getScriptLocation(scriptSelector);
            if (scriptElement) {
                return scriptElement;
            }
            else {
                throw new Error("Can't find script element");
            }
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AsyncAssetsLoader.prototype, "chunkList", {
        /**
         * @ignore
         */
        get: function () {
            var _a;
            var _b = this.props, _c = _b.chunkAttribute, chunkAttribute = _c === void 0 ? 'data-chunks' : _c, _d = _b.baseChunks, baseChunks = _d === void 0 ? [] : _d, scriptSelector = _b.scriptSelector;
            var chunkList = __spreadArrays(baseChunks, ((_a = this.currentScript.getAttribute(chunkAttribute)) !== null && _a !== void 0 ? _a : '').split(','));
            if (chunkList.length) {
                return chunkList;
            }
            throw new Error("You need to specify list of chunks which you want to load in \"" + chunkAttribute + "\" attribute\n                <script " + chunkAttribute + "=\"...\" id=\"" + scriptSelector + "\" src=\"...\"\n        type=\"text/javascript\"></script>\n                ");
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(AsyncAssetsLoader.prototype, "assetsDirUrl", {
        /**
         * @ignore
         */
        get: function () {
            var _a, _b;
            var currentScript = this.currentScript;
            var scriptElement = currentScript;
            var scriptElementSrc = scriptElement.getAttribute('src');
            if (scriptElementSrc) {
                var assetsPath = (_b = (_a = scriptElement.getAttribute('data-assets-path')) !== null && _a !== void 0 ? _a : this.props.assetsPath) !== null && _b !== void 0 ? _b : '/';
                var isAssetPathUrl = assetsPath.match(/^http(s?):\/\//);
                // When assetPath preset as url
                if (isAssetPathUrl) {
                    return assetsPath;
                }
                var loaderFolder = scriptElementSrc.substr(0, scriptElementSrc.lastIndexOf('/'));
                return url_join_1.default(loaderFolder, assetsPath);
            }
            return '';
        },
        enumerable: false,
        configurable: true
    });
    return AsyncAssetsLoader;
}());
exports.default = AsyncAssetsLoader;
//# sourceMappingURL=async-assets-loader.js.map