"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getScriptLocation = void 0;
/**
 * Created by: Andrey Polyakov (andrey@polyakov.im)
 */
/**
 * @ignore
 */
exports.getScriptLocation = function (scriptSelector) {
    var currentScript = document.currentScript;
    if (currentScript && currentScript instanceof HTMLScriptElement) {
        return currentScript;
    }
    var scriptId = document.getElementById(scriptSelector);
    if (scriptId && scriptId instanceof HTMLScriptElement) {
        return scriptId;
    }
    throw new Error("Can't find script element <script id=\"" + scriptSelector + "\" src=\"...\"></script>");
};
//# sourceMappingURL=get-script-location.js.map