import 'unfetch/polyfill';
interface IAsyncAssetsLoaderProps {
    assetsPath?: string;
    assetsFile?: string;
    scriptSelector?: string;
    chunkAttribute?: string;
    baseChunks?: string[];
}
/**
 * @ignore
 */
declare type AssetContent = {
    js?: string | string[];
    css?: string | string[];
};
/**
 * @ignore
 */
declare type IAssetsContent = {
    [x: string]: AssetContent;
};
export default class AsyncAssetsLoader {
    protected props: IAsyncAssetsLoaderProps;
    constructor(props?: IAsyncAssetsLoaderProps);
    init: () => Promise<void>;
    /**
     * @ignore
     */
    get currentScript(): HTMLScriptElement;
    /**
     * @ignore
     */
    get chunkList(): string[];
    /**
     * @ignore
     */
    get assetsDirUrl(): string;
    /**
     * @ignore
     */
    protected fetchAssetContent: () => Promise<IAssetsContent | undefined>;
    /**
     * @ignore
     */
    protected loadCssChunkList: (chunks: string[] | string) => Promise<unknown>;
    /**
     * @ignore
     */
    protected loadCssChunk: (chunkFile: string) => Promise<unknown>;
    /**
     * @ignore
     */
    protected loadJsChunkList: (chunks: string[] | string) => Promise<unknown>;
    /**
     * @ignore
     */
    protected loadJsChunk: (chunkFile: string) => Promise<unknown>;
}
export {};
